/*
By @Elvindevs
*/

const Button = android.widget.Button;
const EditText = android.widget.EditText;
const SeekBar = android.widget.SeekBar;
const ToggleButton = android.widget.ToggleButton;
const TextView = android.widget.TextView;
const ImageView = android.widget.ImageView;
const Toast = android.widget.Toast;
const LinearLayout = android.widget.LinearLayout;
const FrameLayout = android.widget.FrameLayout;
const PopupWindow = android.widget.PopupWindow;
const ScrollView = android.widget.ScrollView;
const HorizontalScrollView = android.widget.HorizontalScrollView;

//widget
const GONE = android.view.View.GONE;
const VISIBLE = android.view.View.VISIBLE;
const OnTouchListener = android.view.View.OnTouchListener;
const OnClickListener = android.view.View.OnClickListener;
const MotionEvent = android.view.MotionEvent;
const Gravity = android.view.Gravity;

//View
const AlertDialog = android.app.AlertDialog;
const Intent = android.content.Intent;
const Uri = android.net.Uri;

//app / content / net
const Bitmap = android.graphics.Bitmap;
const Canvas = android.graphics.Canvas;
const Paint = android.graphics.Paint;
const Drawable = android.graphics.drawable.Drawable;
const BitmapDrawable = android.graphics.drawable.BitmapDrawable;
const ColorDrawable = android.graphics.drawable.ColorDrawable;
const Typeface = android.graphics.Typeface;
const Color = android.graphics.Color;
const BitmapFactory = android.graphics.BitmapFactory;

//Graphics
const File = java.io.File;
const BufferedInputStream = java.io.BufferedInputStream;
const FileInputStream = java.io.FileInputStream;
const InputStream = java.io.InputStream;

//file
const BufferedImage = java.awt.image.BufferedImage;


const ctx = com.mojang.minecraftpe.MainActivity.currentMainActivity.get();
var showMode = "point";
var ic;
var toggle = true;

dp = function (dips) {
return Math.ceil(dips * ctx.getResources().getDisplayMetrics().density);
}

fixdp = function (dips) {
var WIDTH = ctx.getScreenWidth();
var HEIGHT = ctx.getScreenHeight();
return dp(dips) - (16/9 - WIDTH/HEIGHT)*10;
}

createNinePatch = function (bitmap, x, y, xx, yy) {

var NO_COLOR = 0x00000001;

var buffer = java.nio.ByteBuffer.allocate(84).order(
java.nio.ByteOrder.nativeOrder());

buffer.put(0x01);
buffer.put(0x02);
buffer.put(0x02);
buffer.put(0x09);

buffer.putInt(0);
buffer.putInt(0);
buffer.putInt(0);
buffer.putInt(0);
buffer.putInt(0);
buffer.putInt(0);
buffer.putInt(0);
buffer.putInt(y);
buffer.putInt(yy);
buffer.putInt(x);
buffer.putInt(xx);

buffer.putInt(NO_COLOR);
buffer.putInt(NO_COLOR);
buffer.putInt(NO_COLOR);
buffer.putInt(NO_COLOR);
buffer.putInt(NO_COLOR);
buffer.putInt(NO_COLOR);
buffer.putInt(NO_COLOR);
buffer.putInt(NO_COLOR);
buffer.putInt(NO_COLOR);

var drawable = new android.graphics.drawable.NinePatchDrawable(
ctx.getResources(), bitmap, buffer.array(),
new android.graphics.Rect(), null);

return drawable;
}

MCButton = function () {
var bt = new Button(ctx);
bt.setTextColor(Color.parseColor("#ffe1e1e1"));
bt.setAllCaps(false);
bt.setTextSize(14);
bt.setShadowLayer(1, dp(2), dp(2), Color.argb(255, 44, 44, 44));
bt.setOnTouchListener (new OnTouchListener ( {
onTouch: function (view, event) {
if (event.getAction() == MotionEvent.ACTION_DOWN) {
bt.setBackgroundDrawable(Bit_map.PushDrawable());
bt.setTextColor(Color.parseColor("#ffffa1")); 
}

if (event.getAction() == MotionEvent.ACTION_UP) {
bt.setBackgroundDrawable(Bit_map.NormalDrawable());
bt.setTextColor(Color.parseColor("#e1e1e1"));
}

if(event.getAction() == MotionEvent.ACTION_CANCEL) {
	bt.setBackgroundDrawable(Bit_map.NormalDrawable());
	bt.setTextColor(Color.parseColor("#e1e1e1"));
}
return false;
}
}));
bt.setBackgroundDrawable(Bit_map.NormalDrawable());

return bt;
}

var Bit_map = {

sheet : BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/gui/spritesheet.png")),

touchGUI : BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/gui/touchgui.png")),

touchGUI2 : BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/gui/touchgui2.png")),

GUI : BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/gui/gui.png")),

NormalDrawable : function () {
var bitmap = Bitmap.createBitmap(Bit_map.sheet, 8, 32, 8, 8);
var bit = Bitmap.createScaledBitmap(bitmap, dp(16), dp(16), false);
return createNinePatch(bit, dp(4), dp(4), dp(12), dp(14));
},

PushDrawable : function () {
var bitmap = Bitmap.createBitmap(Bit_map.sheet, 0, 32, 8, 8);
var bit = Bitmap.createScaledBitmap(bitmap, dp(16), dp(16), false);
return createNinePatch(bit, dp(4), dp(4), dp(12), dp(14));
},

HeadDrawable: function() {
    var bitmap = Bitmap.createBitmap(Bit_map.touchGUI, 150, 26, 14, 30);

    for (var i = 0; i < 26; i++) {
      bitmap.setPixel(2, i, bitmap.getPixel(3, i));
      bitmap.setPixel(11, i, bitmap.getPixel(10, i));
    }
    for (var i = 3; i < 11; i++) {
      bitmap.setPixel(i, 25, bitmap.getPixel(i, 26));
      bitmap.setPixel(i, 26, bitmap.getPixel(i, 27));
      bitmap.setPixel(i, 27, bitmap.getPixel(i, 28));
      bitmap.setPixel(i, 28, 0x00000000);
    }
    for (var i = 0; i < 14; i++) {
      bitmap.setPixel(i, 25, bitmap.getPixel(4, 25));
      bitmap.setPixel(i, 26, bitmap.getPixel(4, 26));
      bitmap.setPixel(i, 27, bitmap.getPixel(4, 27));
    }
    var bit = Bitmap.createScaledBitmap(bitmap, dp(28), dp(60), false);

    return createNinePatch(bit, dp(5), dp(7), dp(46), dp(22));
  },
  
  EditTextDrawable: function() {
    var O = Color.parseColor("#6B6163");
    var I = Color.parseColor("#393939");

    var color = [O, O, O, O, O, O, O, O, O, O, O, O,
      O, I, I, I, I, I, I, I, I, I, I, O,
      O, I, I, I, I, I, I, I, I, I, I, O,
      O, I, I, I, I, I, I, I, I, I, I, O,
      O, I, I, I, I, I, I, I, I, I, I, O,
      O, I, I, I, I, I, I, I, I, I, I, O,
      O, I, I, I, I, I, I, I, I, I, I, O,
      O, I, I, I, I, I, I, I, I, I, I, O,
      O, I, I, I, I, I, I, I, I, I, I, O,
      O, I, I, I, I, I, I, I, I, I, I, O,
      O, I, I, I, I, I, I, I, I, I, I, O,
      O, O, O, O, O, O, O, O, O, O, O, O,
    ];

    var bit = Bitmap.createBitmap(12, 12, Bitmap.Config.ARGB_8888);
    bit.setPixels(color, 0, 12, 0, 0, 12, 12);

    var bitmap = Bitmap.createScaledBitmap(bit, dp(24), dp(24), false);
    return createNinePatch(bitmap, dp(6), dp(6), dp(18), dp(18));
  },
  
  SeekbarBitmap: function() {
    var bitmap = Bitmap.createBitmap(Bit_map.touchGUI, 225, 125, 11, 17);
    return Bitmap.createScaledBitmap(bitmap, dp(44), dp(68), false);
  },
  SeekbarBackDrawable: function() {
    var bitmap = Bitmap.createBitmap(4, 12, Bitmap.Config.ARGB_8888);
    var c = Color.parseColor("#ff737173");
    var color = [0, 0, 0, 0,
                 0, 0, 0, 0,
                 0, 0, 0, 0,
                 c, c, c, c,
                 c, c, c, c,
                 0, 0, 0, 0,
                 0, 0, 0, 0,
                 0, 0, 0, 0,
                 0, 0, 0, 0,
                 0, 0, 0, 0,
                 0, 0, 0, 0,
                 0, 0, 0, 0,];
    bitmap.setPixels(color, 0, 4, 0, 0, 4, 12);
    var bit = Bitmap.createScaledBitmap(bitmap, dp(16), dp(48), false);
    return new BitmapDrawable(bit);//createNinePatch(bitmap, 0, 0, dp(16), dp(16));
  },
  
  SwitchOffDrawable: function() {
    var bitmap = Bitmap.createBitmap(Bit_map.touchGUI, 160, 206, 38, 19);
    var bit = Bitmap.createScaledBitmap(bitmap, dp(76), dp(38), false);
    return new BitmapDrawable(bit);
  },
  
  SwitchOnDrawable: function() {
    var bitmap = Bitmap.createBitmap(Bit_map.touchGUI, 198, 206, 38, 19);
    var bit = Bitmap.createScaledBitmap(bitmap, dp(76), dp(37), false);
    return new BitmapDrawable(bit);
  },
  
  QuestDrawable: function() {
    var bitmap = Bitmap.createBitmap(Bit_map.GUI, 130, 106, 120, 32);
    var bit = Bitmap.createScaledBitmap(bitmap, dp(240), dp(64), false);
    return new BitmapDrawable(bit);
  }
 }

const Mob = {
	
	getFaceImage: function(type) {
		
		switch(type) {
			
			case "pig":
			
			var dr = Bitmap.createBitmap(BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/mob/pig.png")),8,8,8,8);
			
			return new BitmapDrawable(Bitmap.createScaledBitmap(dr,dp(128),dp(128),false));
			break;
			
			case "cow":
			
			var dr = Bitmap.createBitmap(BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/mob/cow.png")),6,6,8,8);
			
			return new BitmapDrawable(Bitmap.createScaledBitmap(dr,dp(128),dp(128),false));
			break;
			
			case "chicken":
			
			var dr = Bitmap.createBitmap(BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/mob/chicken.png")),3,3,4,6);
			
			return new BitmapDrawable(Bitmap.createScaledBitmap(dr,dp(128),dp(128),false));
			break;
			
			case "mooshcow":
			
			var dr = Bitmap.createBitmap(BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/mob/mooshroom.png")),6,6,8,8);
			
			return new BitmapDrawable(Bitmap.createScaledBitmap(dr,dp(128),dp(128),false));
			break;
			
			case "zombie":
			
			var dr = Bitmap.createBitmap(BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/mob/zombie.png")),8,8,8,8);
			
			return new BitmapDrawable(Bitmap.createScaledBitmap(dr,dp(128),dp(128),false));
			break;
			
			case "pigzombie":
			
			var dr = Bitmap.createBitmap(BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/mob/pigzombie.png")),8,8,8,8);
			
			return new BitmapDrawable(Bitmap.createScaledBitmap(dr,dp(128),dp(128),false));
			break;
			
			case "creeper":
			
			var dr = Bitmap.createBitmap(BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/mob/creeper.png")),8,7,8,8);
			
			return new BitmapDrawable(Bitmap.createScaledBitmap(dr,dp(128),dp(128),false));
			break;
			
			case "skeleton":
			
			var dr = Bitmap.createBitmap(BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/mob/skeleton.png")),8,7,8,8);
			
			return new BitmapDrawable(Bitmap.createScaledBitmap(dr,dp(128),dp(128),false));
			break;
			
			case "squid":
			
			var dr = Bitmap.createBitmap(BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/mob/squid.png")),12,12,12,16);
			
			return new BitmapDrawable(Bitmap.createScaledBitmap(dr,dp(128),dp(128),false));
			break;
			
			case "villager":
			
			var dr = Bitmap.createBitmap(BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/mob/villager/villager.png")),8,7,8,10);
			
			return new BitmapDrawable(Bitmap.createScaledBitmap(dr,dp(128),dp(128),false));
			break;
			
			case "zombievillager":
			
			var dr = Bitmap.createBitmap(BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/mob/zombie_villager/zombie_villager.png")),8,7,8,10);
			
			return new BitmapDrawable(Bitmap.createScaledBitmap(dr,dp(128),dp(128),false));
			break;
			
			case "witch":
			
			var dr = Bitmap.createBitmap(BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/mob/witch.png")),8,7,8,10);
			
			return new BitmapDrawable(Bitmap.createScaledBitmap(dr,dp(128),dp(128),false));
			break;
			
			case "wolf":
			
			var dr = Bitmap.createBitmap(BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/mob/wolf.png")),4,4,6,6);
			
			return new BitmapDrawable(Bitmap.createScaledBitmap(dr,dp(128),dp(128),false));
			break;
			
			case "ocelot":
			
			var dr = Bitmap.createBitmap(BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/mob/cat/ocelot.png")),5,5,5,5);
			
			return new BitmapDrawable(Bitmap.createScaledBitmap(dr,dp(128),dp(128),false));
			break;
			
			case "snowgolem":
			
			var dr = Bitmap.createBitmap(BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/mob/snow_golem.png")),8,8,8,8);
			
			return new BitmapDrawable(Bitmap.createScaledBitmap(dr,dp(128),dp(128),false));
			break;
			
			case "irongolem":
			
			var dr = Bitmap.createBitmap(BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/mob/iron_golem.png")),8,8,8,10);
			
			return new BitmapDrawable(Bitmap.createScaledBitmap(dr,dp(128),dp(128),false));
			break;
			
			case "bat":
			
			var dr = Bitmap.createBitmap(BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/mob/bat.png")),6,6,6,6);
			
			return new BitmapDrawable(Bitmap.createScaledBitmap(dr,dp(128),dp(128),false));
			break;
			
			case "ghast":
			
			var dr = Bitmap.createBitmap(BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/mob/ghast.png")),16,16,16,16);
			
			return new BitmapDrawable(Bitmap.createScaledBitmap(dr,dp(128),dp(128),false));
			break;
		}
	}
}

var mobEntForFace = [

{name: "pig", code: 12},
{name: "cow", code: 11},
{name: "chicken", code: 10},
{name: "mooshcow", code: 16},
{name: "zombie", code: 32},
{name: "pigzombie", code: 36},
{name: "creeper", code: 33},
{name: "skeleton", code: 34},
{name: "squid", code: 17},
{name: "villager", code: 15},
{name: "zombievillager", code: 44},
{name: "witch", code: 45},
{name: "wolf", code: 14},
{name: "ocelot", code: 22},
{name: "snowgolem", code: 21},
{name: "irongolem", code: 20},
{name: "bat", code: 19},
{name: "ghast", code: 41}
];
 
function getEntityNameById(id) {

var mcpeEntities=[

{name: "pig", code: 12},
{name: "cow", code: 11},
{name: "chicken", code: 10},
{name: "mooshcow", code: 16},
{name: "zombie", code: 32},
{name: "pigzombie", code: 36},
{name: "creeper", code: 33},
{name: "skeleton", code: 34},
{name: "squid", code: 17},
{name: "villager", code: 15},
{name: "zombievillager", code: 44},
{name: "witch", code: 45},
{name: "wolf", code: 14},
{name: "ocelot", code: 22},
{name: "snowgolem", code: 21},
{name: "irongolem", code: 20},
{name: "bat", code: 19},
{name: "ghast", code: 41}

];

for(var e=0; e<mcpeEntities.length; e++) {

if(Entity.getEntityTypeId(id)==mcpeEntities[e].id) {

return mcpeEntities[e].name;
}
}
}

function procCmd(cmd) {
	
	if(cmd == "woff" && toggle == true) {
		
		toggle = false;
		clientMessage("§bWaila 비활성화.");
	}
	
	if(cmd == "won" && toggle == false) {
		
		toggle = true;
		clientMessage("§bWaila 활성화.");
	}
}

function newLevel() {

ctx.runOnUiThread (new    java.lang.Thread (new java.lang.Runnable ({
     run: function () {
         try {
  var main = new android.widget.LinearLayout(ctx);
  var iconLay = new android.widget.LinearLayout(ctx);
  var layout = new android.widget.LinearLayout(ctx);
  layout.setOrientation(1);
  
  ic = new android.widget.Button(ctx);
  
  ic.setLayoutParams(new android.widget.LinearLayout.LayoutParams(dp(33),dp(35)));
  ic.setGravity(android.view.Gravity.LEFT);
  
  iconLay.addView(ic);
  
  iconLay.setPadding(0,0,10,0);

  txt = new android.widget.TextView(ctx);
  txt.setText("Unknown");
  txt.setTextSize(14);
     txt.setTextColor(android.graphics.Color.YELLOW);
     txt.setGravity(android.view.Gravity.CENTER);
     
layout.addView(txt);

  subtxt = new android.widget.TextView(ctx);
  subtxt.setText("Unknown");
  subtxt.setTextSize(11);
  subtxt.setTextColor(android.graphics.Color.GRAY);
 subtxt.setGravity(android.view.Gravity.CENTER);
  
  layout.addView(subtxt);
  
  main.addView(iconLay);
  main.addView(layout);
  
  main.setGravity(android.view.Gravity.CENTER);

GUIWindow = new android.widget.PopupWindow(main, dip2px(ctx,200),dip2px(ctx,50), false);
GUIWindow.setBackgroundDrawable(Bit_map.QuestDrawable());
GUIWindow.setTouchable(true); GUIWindow.showAtLocation(ctx.getWindow().getDecorView(), android.view.Gravity.TOP | android.view.Gravity.CENTER, 0,0);
              
     } catch (error) {
       clientMessage ("error : " + error+""+error.lineNumber);
        }
     }
 })));
}

function dip2px(ctx, dips){name:ModPE.loadData
 return Math.ceil(dips * ctx.getResources().getDisplayMetrics().density);}
 
function leaveGame() {
		
		ctx.runOnUiThread (new java.lang.Thread (new java.lang.Runnable ({
   run: function () {
       try {
       	GUIWindow.dismiss();
        } catch (error) {
     print ("error : " + error);
     }
   }
})));
}

function setMcBackground(widget) {

widget.setBackgroundDrawable(Bit_map.NormalDrawable());
}

function modTick() {
	
	if(toggle == true) {

if(showMode == "point") {

var pointId = Player.getPointedBlockId();
var pointData = Player.getPointedBlockData();
var pointEntity = Player.getPointedEntity();

if(pointId == -1) {
	
	pointId = 0;
}
if(pointData == -1) {
	
	pointData = 0;
}
var item = Item.getName(pointId,pointData,false);

if(pointEntity != -1) {
	
	item = getEntityNameById(pointEntity);
	
	pointId = Entity.getEntityTypeId(pointEntity);
	pointData = 0;
}

ctx.runOnUiThread (new java.lang.Thread (new java.lang.Runnable ({
   run: function () {
       try {
       	
       	if(pointEntity == -1) {
       	ic.setBackgroundDrawable(new android.graphics.drawable.BitmapDrawable(createBlockImage(pointId,pointData)));
       	ic.setLayoutParams(new android.widget.LinearLayout.LayoutParams(dp(33),dp(35)));
       	}
       	
   if(pointEntity != -1) {
       		
      for(var e=0; e < mobEntForFace.length; e++) {
      	
      	if(mobEntForFace[e].code == Entity.getEntityTypeId(pointEntity)) {
       		
    	ic.setBackgroundDrawable(Mob.getFaceImage(mobEntForFace[e].name));
    	ic.setLayoutParams(new android.widget.LinearLayout.LayoutParams(dp(35),dp(35)));
    	break;
      }
       					
       					}
       		}
       	txt.setText("  "+item);
       	subtxt.setText("  Id: "+pointId+" Data: "+pointData);
       	
      if(item == null && GUIWindow.isShowing()) {
      GUIWindow.dismiss();
      } else if(item != null && !GUIWindow.isShowing()) {
      newLevel();
      }
        } catch (error) {
     print ("error : " + error);
     }
   }
})));
}
}
}

/*Nogada by Indvel*/
function createBlockImage(id,data) {
	
	BlockImageLoader.init();
	
	if(id == 1 && data == 0) {
		
		return BlockImageLoader.create(["stone", 0], ["stone", 0], ["stone", 0], BlockTypes.CUBE, false);
	}
	if(id == 1 && data == 1) {
		
		return BlockImageLoader.create(["stone", 1], ["stone", 1], ["stone", 1], BlockTypes.CUBE, false);
	}
	if(id == 1 && data == 2) {
		
		return BlockImageLoader.create(["stone", 2], ["stone", 2], ["stone", 2], BlockTypes.CUBE, false);
	}
	if(id == 1 && data == 3) {
		
		return BlockImageLoader.create(["stone", 3], ["stone", 3], ["stone", 3], BlockTypes.CUBE, false);
	}
	if(id == 1 && data == 4) {
		
		return BlockImageLoader.create(["stone", 4], ["stone", 4], ["stone", 4], BlockTypes.CUBE, false);
	}
	if(id == 1 && data == 5) {
		
		return BlockImageLoader.create(["stone", 5], ["stone", 5], ["stone", 5], BlockTypes.CUBE, false);
	}
	if(id == 1 && data == 6) {
		
		return BlockImageLoader.create(["stone", 6], ["stone", 6], ["stone", 6], BlockTypes.CUBE, false);
	}
	if(id == 2 && data == 0) {
		return BlockImageLoader.create(["grass", 3], ["grass", 3], ["grass", 2], BlockTypes.CUBE, false);
	}
	if(id == 3 && data == 0) {
		return BlockImageLoader.create(["dirt", 0], ["dirt", 0], ["dirt", 0], BlockTypes.CUBE, false);
	}
	if(id == 4 && data == 0) {
		return BlockImageLoader.create(["cobblestone", 0], ["cobblestone", 0], ["cobblestone", 0], BlockTypes.CUBE, false);
	}
	if(id == 5 && data == 0) {
		return BlockImageLoader.create(["planks", 0], ["planks", 0], ["planks", 0], BlockTypes.CUBE, false);
	}
	if(id == 5 && data == 1) {
		return BlockImageLoader.create(["planks", 1], ["planks", 1], ["planks", 1], BlockTypes.CUBE, false);
	}
	if(id == 5 && data == 2) {
		return BlockImageLoader.create(["planks", 2], ["planks", 2], ["planks", 2], BlockTypes.CUBE, false);
	}
	if(id == 5 && data == 3) {
		return BlockImageLoader.create(["planks", 3], ["planks", 3], ["planks", 3], BlockTypes.CUBE, false);
	}
	if(id == 5 && data == 4) {
		return BlockImageLoader.create(["planks", 4], ["planks", 4], ["planks", 4], BlockTypes.CUBE, false);
	}
	if(id == 5 && data == 5) {
		return BlockImageLoader.create(["planks", 5], ["planks", 5], ["planks", 5], BlockTypes.CUBE, false);
	}
	if(id == 6 && data == 0) {
		return BlockImageLoader.create(["sapling", 0], ["sapling", 0], ["sapling", 0], BlockTypes.NONE, false);
	}
	if(id == 6 && data == 1) {
		return BlockImageLoader.create(["sapling", 2], ["sapling", 2], ["sapling", 2], BlockTypes.NONE, false);
	}
	if(id == 6 && data == 2) {
		return BlockImageLoader.create(["sapling", 1], ["sapling", 1], ["sapling", 1], BlockTypes.NONE, false);
	}
	if(id == 6 && data == 3) {
		return BlockImageLoader.create(["sapling", 3], ["sapling", 3], ["sapling", 3], BlockTypes.NONE, false);
	}
	if(id == 6 && data == 4) {
		return BlockImageLoader.create(["sapling", 4], ["sapling", 4], ["sapling", 4], BlockTypes.NONE, false);
	}
	if(id == 6 && data == 5) {
		return BlockImageLoader.create(["sapling", 5], ["sapling", 5], ["sapling", 5], BlockTypes.NONE, false);
	}
	if(id == 7 && data == 0) {
		return BlockImageLoader.create(["bedrock", 0], ["bedrock", 0], ["bedrock", 0], BlockTypes.CUBE, false);
	}
	if(id == 12 && data == 0) {
		return BlockImageLoader.create(["sand", 0], ["sand", 0], ["sand", 0], BlockTypes.CUBE, false);
	}
	if(id == 12 && data == 1) {
		return BlockImageLoader.create(["sand", 1], ["sand", 1], ["sand", 1], BlockTypes.CUBE, false);
	}
	if(id == 13 && data == 0) {
		return BlockImageLoader.create(["gravel", 0], ["gravel", 0], ["gravel", 0], BlockTypes.CUBE, false);
	}
	if(id == 14 && data == 0) {
		return BlockImageLoader.create(["gold_ore", 0], ["gold_ore", 0], ["gold_ore", 0], BlockTypes.CUBE, false);
	}
	if(id == 15 && data == 0) {
		return BlockImageLoader.create(["iron_ore", 0], ["iron_ore", 0], ["iron_ore", 0], BlockTypes.CUBE, false);
	}
	if(id == 16 && data == 0) {
		return BlockImageLoader.create(["coal_ore", 0], ["coal_ore", 0], ["coal_ore", 0], BlockTypes.CUBE, false);
	}
	if(id == 18 && data == 8) {
		return BlockImageLoader.create(["leaves", 0], ["leaves", 0], ["leaves", 0], BlockTypes.CUBE, false);
	}
	if(id == 18 && data == 9) {
		return BlockImageLoader.create(["leaves", 1], ["leaves", 1], ["leaves", 1], BlockTypes.CUBE, false);
	}
	if(id == 18 && data == 10) {
		return BlockImageLoader.create(["leaves", 2], ["leaves", 2], ["leaves", 2], BlockTypes.CUBE, false);
	}
	if(id == 18 && data == 11) {
		return BlockImageLoader.create(["leaves", 3], ["leaves", 3], ["leaves", 3], BlockTypes.CUBE, false);
	}
	if(id == 19 && data == 0) {
		return BlockImageLoader.create(["sponge", 0], ["sponge", 0], ["sponge", 0], BlockTypes.CUBE, false);
	}
	if(id == 20 && data == 0) {
		return BlockImageLoader.create(["glass", 0], ["glass", 0], ["glass", 0], BlockTypes.CUBE, false);
	}
	if(id == 21 && data == 0) {
		return BlockImageLoader.create(["lapis_ore", 0], ["lapis_ore", 0], ["lapis_ore", 0], BlockTypes.CUBE, false);
	}
	if(id == 22 && data == 0) {
		return BlockImageLoader.create(["lapis_block", 0], ["lapis_block", 0], ["lapis_block", 0], BlockTypes.CUBE, false);
	}
	if(id == 23 && data == 0) {
		return BlockImageLoader.create(["dispenser_front_horizontal", 0], ["dispenser_front_horizontal", 0], ["dispenser_front_horizontal", 0], BlockTypes.CUBE, false);
	}
	if(id == 24 && data == 0) {
		return BlockImageLoader.create(["sandstone", 0], ["sandstone", 0], ["sandstone", 0], BlockTypes.CUBE, false);
	}
	if(id == 24 && data == 1) {
		return BlockImageLoader.create(["sandstone", 1], ["sandstone", 1], ["sandstone", 1], BlockTypes.CUBE, false);
	}
	if(id == 24 && data == 2) {
		return BlockImageLoader.create(["sandstone", 2], ["sandstone", 2], ["sandstone", 2], BlockTypes.CUBE, false);
	}
	if(id == 25 && data == 0) {
		return BlockImageLoader.create(["noteblock", 0], ["noteblock", 0], ["noteblock", 0], BlockTypes.CUBE, false);
	}
	if(id == 26 && data == 0) {
		return BlockImageLoader.create(["bed", 0], ["bed", 0], ["bed", 0], BlockTypes.CUBE, false);
	}
	if(id == 27 && data == 0) {
		return BlockImageLoader.create(["rail_golden", 0], ["rail_golden", 0], ["rail_golden", 0], BlockTypes.NONE, false);
	}
	if(id == 28 && data == 0) {
		return BlockImageLoader.create(["railWdetector", 0], ["rail_detector", 0], ["rail_detector", 0], BlockTypes.NONE, false);
	}
	if(id == 30 && data == 0) {
		return BlockImageLoader.create(["web", 0], ["web", 0], ["web", 0], BlockTypes.NONE, false);
	}
	if(id == 31) {
		return BlockImageLoader.create(["tallgrass", 0], ["tallgrass", 0], ["tallgrass", 0], BlockTypes.NONE, false);
	}
	
	if(id == 35 && data == 0) {
		return BlockImageLoader.create(["wool", 0], ["wool", 0], ["wool", 0], BlockTypes.CUBE, false);
	}
	if(id == 35 && data == 1) {
		return BlockImageLoader.create(["wool", 1], ["wool", 1], ["wool", 1], BlockTypes.CUBE, false);
	}
	if(id == 35 && data == 2) {
		return BlockImageLoader.create(["wool", 2], ["wool", 2], ["wool", 2], BlockTypes.CUBE, false);
	}
	if(id == 35 && data == 3) {
		return BlockImageLoader.create(["wool", 3], ["wool", 3], ["wool", 3], BlockTypes.CUBE, false);
	}
	if(id == 35 && data == 4) {
		return BlockImageLoader.create(["wool", 4], ["wool", 4], ["wool", 4], BlockTypes.CUBE, false);
	}
	if(id == 35 && data == 5) {
		return BlockImageLoader.create(["wool", 5], ["wool", 5], ["wool", 5], BlockTypes.CUBE, false);
	}
	if(id == 35 && data == 6) {
		return BlockImageLoader.create(["wool", 6], ["wool", 6], ["wool", 6], BlockTypes.CUBE, false);
	}
	if(id == 35 && data == 7) {
		return BlockImageLoader.create(["wool", 7], ["wool", 7], ["wool", 7], BlockTypes.CUBE, false);
	}
	if(id == 35 && data == 8) {
		return BlockImageLoader.create(["wool", 8], ["wool", 8], ["wool", 8], BlockTypes.CUBE, false);
	}
	if(id == 35 && data == 9) {
		return BlockImageLoader.create(["wool", 9], ["wool", 9], ["wool", 9], BlockTypes.CUBE, false);
	}
	if(id == 35 && data == 10) {
		return BlockImageLoader.create(["wool",10], ["wool", 10], ["wool", 10], BlockTypes.CUBE, false);
	}
	if(id == 35 && data == 11) {
		return BlockImageLoader.create(["wool", 11], ["wool", 11], ["wool", 11], BlockTypes.CUBE, false);
	}
	if(id == 35 && data == 12) {
		return BlockImageLoader.create(["wool", 12], ["wool", 12], ["wool", 12], BlockTypes.CUBE, false);
	}
	if(id == 35 && data == 13) {
		return BlockImageLoader.create(["wool", 13], ["wool", 13], ["wool", 13], BlockTypes.CUBE, false);
	}
	if(id == 35 && data == 14) {
		return BlockImageLoader.create(["wool", 14], ["wool", 14], ["wool", 14], BlockTypes.CUBE, false);
	}
	if(id == 35 && data == 15) {
		return BlockImageLoader.create(["wool", 15], ["wool", 15], ["wool", 15], BlockTypes.CUBE, false);
	}
	if(id == 37 && data == 0) {
		return BlockImageLoader.create(["flower1", 0], ["flower1", 0], ["flower1", 0], BlockTypes.NONE, false);
	}
	if(id == 38 && data == 0) {
		return BlockImageLoader.create(["flower2", 0], ["flower2", 0], ["flower2", 0], BlockTypes.NONE, false);
	}
	if(id == 38 && data == 1) {
		return BlockImageLoader.create(["flower2", 1], ["flower2", 1], ["flower2", 1], BlockTypes.NONE, false);
	}
	if(id == 38 && data == 2) {
		return BlockImageLoader.create(["flower2", 2], ["flower2", 2], ["flower2", 2], BlockTypes.NONE, false);
	}
	if(id == 38 && data == 3) {
		return BlockImageLoader.create(["flower2", 3], ["flower2", 3], ["flower2", 3], BlockTypes.NONE, false);
	}
	if(id == 38 && data == 4) {
		return BlockImageLoader.create(["flower2", 4], ["flower2", 4], ["flower2", 4], BlockTypes.NONE, false);
	}
	if(id == 38 && data == 5) {
		return BlockImageLoader.create(["flower2", 5], ["flower2", 5], ["flower2", 5], BlockTypes.NONE, false);
	}
	if(id == 38 && data == 6) {
		return BlockImageLoader.create(["flower2", 6], ["flower2", 6], ["flower2", 6], BlockTypes.NONE, false);
	}
	if(id == 38 && data == 7) {
		return BlockImageLoader.create(["flower2", 7], ["flower2", 7], ["flower2", 7], BlockTypes.NONE, false);
	}
	if(id == 38 && data == 8) {
		return BlockImageLoader.create(["flower2", 8], ["flower2", 8], ["flower2", 8], BlockTypes.NONE, false);
	}
	if(id == 39 && data == 0) {
		return BlockImageLoader.create(["mushroom_brown", 0], ["mushroom_brown", 0], ["mushroom_brown", 0], BlockTypes.NONE, false);
	}
	if(id == 40 && data == 0) {
		return BlockImageLoader.create(["mushroom_red", 0], ["mushroom_red", 0], ["mushroom_red", 0], BlockTypes.NONE, false);
	}
	if(id == 41 && data == 0) {
		return BlockImageLoader.create(["gold_block", 0], ["gold_block", 0], ["gold_block", 0], BlockTypes.CUBE, false);
	}
	if(id == 42 && data == 0) {
		return BlockImageLoader.create(["iron_block", 0], ["iron_block", 0], ["iron_block", 0], BlockTypes.CUBE, false);
	}
	if(id == 43 && data == 0) {
		return BlockImageLoader.create(["stone_slab", 0], ["stone_slab", 0], ["stone_slab", 0], BlockTypes.CUBE, false);
	}
	if(id == 43 && data == 1) {
		return BlockImageLoader.create(["stone_slab", 0], ["stone_slab", 0], ["stone_slab", 0], BlockTypes.CUBE, false);
	}
	if(id == 43 && data == 2) {
		return BlockImageLoader.create(["stone_slab", 0], ["stone_slab", 0], ["stone_slab", 0], BlockTypes.CUBE, false);
	}
	if(id == 43 && data == 3) {
		return BlockImageLoader.create(["stone_slab", 0], ["stone_slab", 0], ["stone_slab", 0], BlockTypes.CUBE, false);
	}
	if(id == 43 && data == 4) {
		return BlockImageLoader.create(["stone_slab", 0], ["stone_slab", 0], ["stone_slab", 0], BlockTypes.CUBE, false);
	}
	if(id == 43 && data == 5) {
		return BlockImageLoader.create(["stone_slab", 0], ["stone_slab", 0], ["stone_slab", 0], BlockTypes.CUBE, false);
	}
	if(id == 43 && data == 6) {
		return BlockImageLoader.create(["stone_slab", 0], ["stone_slab", 0], ["stone_slab", 0], BlockTypes.CUBE, false);
	}
	if(id == 43 && data == 7) {
		return BlockImageLoader.create(["stone_slab", 0], ["stone_slab", 0], ["stone_slab", 0], BlockTypes.CUBE, false);
}
if(id == 44 && data == 0) {
		return BlockImageLoader.create(["stone_slab", 0], ["stone_slab", 0], ["stone_slab", 0], BlockTypes.CUBE, false);
	}
	if(id == 44 && data == 1) {
		return BlockImageLoader.create(["stone_slab", 0], ["stone_slab", 0], ["stone_slab", 0], BlockTypes.CUBE, false);
	}
	if(id == 44 && data == 2) {
		return BlockImageLoader.create(["stone_slab", 0], ["stone_slab", 0], ["stone_slab", 0], BlockTypes.CUBE, false);
	}
	if(id == 44 && data == 3) {
		return BlockImageLoader.create(["stone_slab", 0], ["stone_slab", 0], ["stone_slab", 0], BlockTypes.CUBE, false);
	}
	if(id == 44 && data == 4) {
		return BlockImageLoader.create(["stone_slab", 0], ["stone_slab", 0], ["stone_slab", 0], BlockTypes.CUBE, false);
	}
	if(id == 44 && data == 5) {
		return BlockImageLoader.create(["stone_slab", 0], ["stone_slab", 0], ["stone_slab", 0], BlockTypes.CUBE, false);
	}
	if(id == 44 && data == 6) {
		return BlockImageLoader.create(["stone_slab", 0], ["stone_slab", 0], ["stone_slab", 0], BlockTypes.CUBE, false);
	}
	if(id == 44 && data == 7) {
		return BlockImageLoader.create(["stone_slab", 0], ["stone_slab", 0], ["stone_slab", 0], BlockTypes.CUBE, false);
 }
if(id == 45 && data == 0) {
		return BlockImageLoader.create(["brick", 0], ["brick", 0], ["brick", 0], BlockTypes.CUBE, false);
	}
	if(id == 46 && data == 0) {
		return BlockImageLoader.create(["tnt", 0], ["tnt", 0], ["tnt", 1], BlockTypes.CUBE, false);
	}
	if(id == 47 && data == 0) {
		return BlockImageLoader.create(["bookshelf", 0], ["bookshelf", 0], ["planks", 0], BlockTypes.CUBE, false);
	}
	if(id == 48 && data == 0) {
		return BlockImageLoader.create(["cobblestone_mossy", 0], ["cobblestone_mossy", 0], ["cobblestone_mossy", 0], BlockTypes.CUBE, false);
	}
	if(id == 49 && data == 0) {
		return BlockImageLoader.create(["obsidian", 0], ["obsidian", 0], ["obsidian", 0], BlockTypes.CUBE, false);
	}
	if(id == 50 && data == 5) {
		return BlockImageLoader.create(["torch_on", 0], ["torch_on", 0], ["torch_on", 0], BlockTypes.NONE, false);
	}
	if(id == 51 && data == 0) {
		return BlockImageLoader.create(["fire", 0], ["fire", 0], ["fire", 0], BlockTypes.NONE, false);
	}
	if(id == 52 && data == 0) {
		return BlockImageLoader.create(["mob_spawner", 0], ["mob_spawner", 0], ["mob_spawner", 0], BlockTypes.CUBE, false);
	}
	if(id == 54) {
		return BlockImageLoader.create(["chest_inventory", 2], ["chest_inventory", 1], ["chest_inventory", 0], BlockTypes.CUBE, false);
	}
	if(id == 55 && data == 0) {
		return BlockImageLoader.create(["redstone_dust_cross", 0], ["redstone_dust_cross", 0], ["redstone_dust_cross", 0], BlockTypes.NONE, false);
	}
	if(id == 56 && data == 0) {
		return BlockImageLoader.create(["diamond_ore", 0], ["diamond_ore", 0], ["diamond_ore", 0], BlockTypes.CUBE, false);
	}
	if(id == 57 && data == 0) {
		return BlockImageLoader.create(["diamond_block", 0], ["diamond_block", 0], ["diamond_block", 0], BlockTypes.CUBE, false);
	}
	if(id == 58 && data == 0) {
		return BlockImageLoader.create(["crafting_table", 1], ["crafting_table", 2], ["crafting_table", 0], BlockTypes.CUBE, false);
	}
	if(id == 60 && data == 0) {
		return BlockImageLoader.create(["farmland", 0], ["farmland", 0], ["farmland", 0], BlockTypes.CUBE, false);
	}
	if(id == 61 && data == 5) {
		return BlockImageLoader.create(["furnace", 0], ["furnace", 2], ["furnace", 3], BlockTypes.CUBE, false);
	}
	if(id == 62 && data == 5) {
		return BlockImageLoader.create(["furnace", 1], ["furnace", 2], ["furnace", 3], BlockTypes.CUBE, false);
	}
	if(id == 64 && data == 2) {
		return BlockImageLoader.create(["door", 0], ["door", 0], ["door", 0], BlockTypes.NONE, false);
	}
	if(id == 64 && data == 8) {
		return BlockImageLoader.create(["door", 1], ["door", 1], ["door", 1], BlockTypes.NONE, false);
	}
	if(id == 65 && data == 5) {
		return BlockImageLoader.create(["ladder", 0], ["ladder", 0], ["ladder", 0], BlockTypes.NONE, false);
	}
	if(id == 66 && data == 0) {
		return BlockImageLoader.create(["rail_normal", 0], ["rail_normal", 0], ["rail_normal", 0], BlockTypes.NONE, false);
	}
	if(id == 69 && data == 5) {
		return BlockImageLoader.create(["lever", 0], ["lever", 0], ["lever", 0], BlockTypes.NONE, false);
	}
	if(id == 71 && data == 2) {
		return BlockImageLoader.create(["door", 12], ["door", 12], ["door1", 12], BlockTypes.NONE, false);
	}
	if(id == 71 && data == 8) {
		return BlockImageLoader.create(["door", 13], ["door", 13], ["door", 13], BlockTypes.NONE, false);
	}
	if(id == 73 && data == 0) {
		return BlockImageLoader.create(["redstone_ore", 0], ["redstone_ore", 0], ["redstone_ore", 0], BlockTypes.CUBE, false);
	}
	if(id == 74 && data == 0) {
		return BlockImageLoader.create(["redstone_ore", 1], ["redstone_ore", 1], ["redstone_ore", 1], BlockTypes.CUBE, false);
	}
	if(id == 75 && data == 5) {
		return BlockImageLoader.create(["redstone_torch_off", 0], ["redstone_torch_off", 0], ["redstone_torch_off", 0], BlockTypes.NONE, false);
	}
	if(id == 76 && data == 5) {
		return BlockImageLoader.create(["redstone_torch_on", 0], ["redstone_torch_on", 0], ["redstone_torch_on", 0], BlockTypes.NONE, false);
	}
	if(id == 78 && data == 0) {
		return BlockImageLoader.create(["snow", 0], ["snow", 0], ["snow", 0], BlockTypes.SNOW, false);
	}
	if(id == 79 && data == 0) {
		return BlockImageLoader.create(["ice", 0], ["ice", 0], ["ice", 0], BlockTypes.CUBE, false);
	}
	if(id == 80 && data == 0) {
		return BlockImageLoader.create(["snow", 0], ["snow", 0], ["snow", 0], BlockTypes.CUBE, false);
	}
	if(id == 81 && data == 0) {
		return BlockImageLoader.create(["cactus", 1], ["cactus", 1], ["cactus", 0], BlockTypes.CUBE, false);
	}
	if(id == 82 && data == 0) {
		return BlockImageLoader.create(["clay", 0], ["clay", 0], ["clay", 0], BlockTypes.CUBE, false);
	}
	if(id == 87 && data == 0) {
		return BlockImageLoader.create(["netherrack", 0], ["netherrack", 0], ["netherrack", 0], BlockTypes.CUBE, false);
	}
	if(id == 88 && data == 0) {
		return BlockImageLoader.create(["soul_sand", 0], ["soul_sand", 0], ["soul_sand", 0], BlockTypes.CUBE, false);
	}
	if(id == 89 && data == 0) {
		return BlockImageLoader.create(["glowstone", 0], ["glowstone", 0], ["glowstone", 0], BlockTypes.CUBE, false);
	}
	if(id == 90 && data == 0) {
		return BlockImageLoader.create(["portal", 0], ["portal", 0], ["portal", 0], BlockTypes.NONE, false);
	}
	if(id == 92 && data == 0) {
		return BlockImageLoader.create(["cake_side", 0], ["cake_side", 0], ["cake_top", 0], BlockTypes.SLAB, false);
	}
	if(id == 93) {
		return BlockImageLoader.create(["repeater_off", 0], ["repeater_off", 0], ["repeater_off", 0], BlockTypes.SNOW, false);
	}
	if(id == 94) {
		return BlockImageLoader.create(["repeater_on", 0], ["repeater_on", 0], ["repeater_on", 0], BlockTypes.SNOW, false);
	}
	if(id == 96) {
		return BlockImageLoader.create(["trapdoor", 0], ["trapdoor", 0], ["trapdoor", 0], BlockTypes.TRAPDOOR, false);
	}
	if(id == 98 && data == 0) {
		return BlockImageLoader.create(["stonebrick", 0], ["stonebrick", 0], ["stonebrick", 0], BlockTypes.CUBE, false);
	}
	if(id == 98 && data == 1) {
		return BlockImageLoader.create(["stonebrick", 1], ["stonebrick", 1], ["stonebrick", 1], BlockTypes.CUBE, false);
	}
	if(id == 98 && data == 2) {
		return BlockImageLoader.create(["stonebrick", 2], ["stonebrick", 2], ["stonebrick", 2], BlockTypes.CUBE, false);
	}
	if(id == 101 && data == 0) {
		return BlockImageLoader.create(["iron_bars", 0], ["iron_bars", 0], ["iron_bars", 0], BlockTypes.NONE, false);
	}
	if(id == 102 && data == 0) {
		return BlockImageLoader.create(["glass_pane_top", 0], ["glass_pane_top", 0], ["glass_pane_top", 0], BlockTypes.NONE, false);
	}
	if(id == 103 && data == 0) {
		return BlockImageLoader.create(["melon", 0], ["melon", 0], ["melon", 0], BlockTypes.CUBE, false);
	}
	if(id == 106 && data == 1) {
		return BlockImageLoader.create(["vine", 0], ["vine", 0], ["vine", 0], BlockTypes.NONE, false);
	}
	if(id == 110 && data == 0) {
		return BlockImageLoader.create(["mycelium", 0], ["mycelium", 0], ["mycelium", 0], BlockTypes.NONE, false);
	}
	if(id == 112 && data == 0) {
		return BlockImageLoader.create(["netherbrick", 0], ["netherbrick", 0], ["netherbrick", 0], BlockTypes.CUBE, false);
	}
	if(id == 115 && data == 0) {
		return BlockImageLoader.create(["nether_wart", 0], ["nether_wart", 0], ["nether_wart", 0], BlockTypes.NONE, false);
	}
	if(id == 116 && data == 0) {
		return BlockImageLoader.create(["enchanting_table_side", 0], ["enchanting_table_side", 0], ["enchanting_table_top", 0], BlockTypes.ENCHANTTABLE, false);
	}
	if(id == 117 && data == 0) {
		return BlockImageLoader.create(["brewing_stand", 0], ["brewing_stand", 0], ["brewing_stand", 0], BlockTypes.NONE, false);
	}
	if(id == 118 && data == 0) {
		return BlockImageLoader.create(["cauldron_side", 0], ["cauldron_side", 0], ["cauldron_side", 0], BlockTypes.NONE, false);
	}
	if(id == 120) {
		return BlockImageLoader.create(["endframee", 0], ["endframee", 0], ["endframee", 0], BlockTypes.NONE, false);
	}
	if(id == 121 && data == 0) {
		return BlockImageLoader.create(["end_stone", 0], ["end_stone", 0], ["end_stone", 0], BlockTypes.CUBE, false);
	}
	if(id == 123) {
		return BlockImageLoader.create(["redstone_lamp_off", 0], ["redstone_lamp_off", 0], ["redstone_lamp_off", 0], BlockTypes.CUBE, false);
	}
	if(id == 124 && data == 0) {
		return BlockImageLoader.create(["redstone_lamp_on", 0], ["redstone_lamp_on", 0], ["redstone_lamp_on", 0], BlockTypes.CUBE, false);
	}
	if(id == 126) {
		return BlockImageLoader.create(["rail_activator", 0], ["rail_activator", 0], ["rail_activator", 0], BlockTypes.NONE, false);
	}
	if(id == 127) {
		return BlockImageLoader.create(["cocoa", 0], ["cocoa", 0], ["cocoa", 0], BlockTypes.NONE, false);
	}
	if(id == 129 && data == 0) {
		return BlockImageLoader.create(["emerald_ore", 0], ["emerald_ore", 0], ["emerald_ore", 0], BlockTypes.CUBE, false);
	}
	if(id == 131) {
		return BlockImageLoader.create(["trip_wire_source", 0], ["trip_wire_source", 0], ["trip_source", 0], BlockTypes.NONE, false);
	}
	if(id == 132) {
		return BlockImageLoader.create(["trip_wire", 0], ["trip_wire", 0], ["trip_wire", 0], BlockTypes.NONE, false);
	}
	if(id == 133 && data == 0) {
		return BlockImageLoader.create(["emerald_block", 0], ["emerald_block", 0], ["emerald_block", 0], BlockTypes.CUBE, false);
	}
	if(id == 140) {
		return BlockImageLoader.create(["double_plant_carried", 0], ["double_plant_carried", 0], ["double_plant_carried", 0], BlockTypes.NONE, false);
	}
	if(id == 141) {
		return BlockImageLoader.create(["carrots", 0], ["carrots", 0], ["cartots", 0], BlockTypes.NONE, false);
	}
	if(id == 142) {
		return BlockImageLoader.create(["potatoes", 0], ["potatoes", 0], ["potatoes", 0], BlockTypes.NONE, false);
	}
	if(id == 145) {
		return BlockImageLoader.create(["anvil_base", 0], ["anvil_base", 0], ["anvil_base", 0], BlockTypes.NONE, false);
	}
	if(id == 149) {
		return BlockImageLoader.create(["comparator_off", 0], ["comparator_off", 0], ["comparator_off", 0], BlockTypes.SNOW, false);
	}
	if(id == 150) {
		return BlockImageLoader.create(["comparator_on", 0], ["comparator_on", 0], ["comparator_on", 0], BlockTypes.SNOW, false);
	}
	if(id == 151) {
		return BlockImageLoader.create(["daylight_detector_side", 0], ["daylight_detector_side", 0], ["daylight_detector_top", 0], BlockTypes.SLAB, false);
	}
	if(id == 152 && data == 0) {
		return BlockImageLoader.create(["redstone_block", 0], ["redstone_block", 0], ["redstone_block", 0], BlockTypes.CUBE, false);
	}
	if(id == 154 && data == 0) {
		return BlockImageLoader.create(["hopper_outside", 0], ["hopper_outside", 0], ["hopper_outside", 0], BlockTypes.NONE, false);
	}
	if(id == 155 && data == 0) {
		return BlockImageLoader.create(["quartz_block", 0], ["quartz_block", 0], ["quartz_block", 0], BlockTypes.CUBE, false);
	}
	if(id == 155 && data == 1) {
		return BlockImageLoader.create(["quartz_block", 1], ["quartz_block", 1], ["quartz_block", 1], BlockTypes.CUBE, false);
	}
	if(id == 155 && data == 2) {
		return BlockImageLoader.create(["quartz_block", 2], ["quartz_block", 2], ["quartz_block", 2], BlockTypes.CUBE, false);
	}
	if(id == 159 && data == 0) {
		return BlockImageLoader.create(["stained_clay", 0], ["stained_clay", 0], ["stained_clay", 0], BlockTypes.CUBE, false);
	}
	if(id == 159 && data == 1) {
		return BlockImageLoader.create(["stained_clay", 1], ["stained_clay", 1], ["stained_clay", 1], BlockTypes.CUBE, false);
	}
	if(id == 159 && data == 2) {
		return BlockImageLoader.create(["stained_clay", 2], ["stained_clay", 2], ["stained_clay", 2], BlockTypes.CUBE, false);
	}
	if(id == 159 && data == 3) {
		return BlockImageLoader.create(["stained_clay", 3], ["stained_clay", 3], ["stained_clay", 3], BlockTypes.CUBE, false);
	}
	if(id == 159 && data == 4) {
		return BlockImageLoader.create(["stained_clay", 4], ["stained_clay", 4], ["stained_clay", 4], BlockTypes.CUBE, false);
	}
	if(id == 159 && data == 5) {
		return BlockImageLoader.create(["stained_clay", 5], ["stained_clay", 5], ["stained_clay", 5], BlockTypes.CUBE, false);
	}
	if(id == 159 && data == 6) {
		return BlockImageLoader.create(["stained_clay", 6], ["stained_clay", 6], ["stained_clay", 6], BlockTypes.CUBE, false);
	}
	if(id == 159 && data == 7) {
		return BlockImageLoader.create(["stained_clay", 7], ["stained_clay", 7], ["stained_clay", 7], BlockTypes.CUBE, false);
	}
	if(id == 159 && data == 8) {
		return BlockImageLoader.create(["stained_clay", 8], ["stained_clay", 8], ["stained_clay", 8], BlockTypes.CUBE, false);
	}
	if(id == 159 && data == 9) {
		return BlockImageLoader.create(["stained_clay", 9], ["stained_clay", 9], ["stained_clay", 9], BlockTypes.CUBE, false);
	}
	if(id == 159 && data == 10) {
		return BlockImageLoader.create(["stained_clay", 10], ["stained_clay", 10], ["stained_clay", 10], BlockTypes.CUBE, false);
	}
	if(id == 159 && data == 11) {
		return BlockImageLoader.create(["stained_clay", 11], ["stained_clay", 11], ["stained_clay", 11], BlockTypes.CUBE, false);
	}
	if(id == 159 && data == 12) {
		return BlockImageLoader.create(["stained_clay", 12], ["stained_clay", 12], ["stained_clay", 12], BlockTypes.CUBE, false);
	}
	if(id == 159 && data == 13) {
		return BlockImageLoader.create(["stained_clay", 13], ["stained_clay", 13], ["stained_clay", 13], BlockTypes.CUBE, false);
	}
	if(id == 159 && data == 14) {
		return BlockImageLoader.create(["stained_clay", 14], ["stained_clay", 14], ["stained_clay", 14], BlockTypes.CUBE, false);
	}
	if(id == 159 && data == 15) {
		return BlockImageLoader.create(["stained_clay", 15], ["stained_clay", 15], ["stained_clay", 15], BlockTypes.CUBE, false);
	}
	if(id == 165 && data == 0) {
		return BlockImageLoader.create(["slime_block", 0], ["slime_block", 0], ["slime_block", 0], BlockTypes.CUBE, false);
	}
	if(id == 167) {
		return BlockImageLoader.create(["iron_trapdoor", 0], ["iron_trapdoor", 0], ["iron_trapdoor", 0], BlockTypes.CUBE, false);
	}
	if(id == 170 && data == 0) {
		return BlockImageLoader.create(["hayblock", 0], ["hayblock", 0], ["hayblock", 0], BlockTypes.CUBE, false);
	}
	if(id == 172 && data == 0) {
		return BlockImageLoader.create(["hardened_clay", 0], ["hardened_clay", 0], ["hardened_clay", 0], BlockTypes.CUBE, false);
	}
	if(id == 173 && data == 0) {
		return BlockImageLoader.create(["coal_block", 0], ["coal_block", 0], ["coal_block", 0], BlockTypes.CUBE, false);
	}
	if(id == 174 && data == 0) {
		return BlockImageLoader.create(["ice_packed", 0], ["ice_packed", 0], ["ice_packed", 0], BlockTypes.CUBE, false);
	}
	if(id == 175 && data == 0) {
		return BlockImageLoader.create(["sunflower_additional", 0], ["sunflower_additional", 0], ["sunflower_additional", 0], BlockTypes.NONE, false);
	}
	if(id == 175 && data == 1) {
		return BlockImageLoader.create(["sunflower_additional", 1], ["sunflower_additional", 1], ["sunflower_additional", 1], BlockTypes.NONE, false);
	}
	if(id == 175 && data == 2) {
		return BlockImageLoader.create(["tallgrass", 0], ["tallgrass", 0], ["tallgrass", 0], BlockTypes.NONE, false);
	}
	if(id == 175 && data == 3) {
		return BlockImageLoader.create(["sunflower_additional", 3], ["sunflower_additional", 3], ["sunflower_additional", 3], BlockTypes.NONE, false);
	}
	if(id == 175 && data == 0) {
		return BlockImageLoader.create(["sunflower_additional", 4], ["sunflower_additional", 4], ["sunflower_additional", 4], BlockTypes.NONE, false);
	}
	if(id == 175 && data == 5) {
		return BlockImageLoader.create(["sunflower_additional", 5], ["sunflower_additional", 5], ["sunflower_additional", 5], BlockTypes.NONE, false);
	}
	if(id == 179 && data == 0) {
		return BlockImageLoader.create(["redsandstone", 0], ["redsandstone", 0], ["redsandstone", 0], BlockTypes.CUBE, false);
	}
	if(id == 179 && data == 1) {
		return BlockImageLoader.create(["redsandstone", 1], ["redsandstone", 1], ["redsandstone", 1], BlockTypes.CUBE, false);
	}
	if(id == 179 && data == 2) {
		return BlockImageLoader.create(["redsandstone", 2], ["redsandstone", 2], ["redsandstone", 0], BlockTypes.CUBE, false);
	}
	if(id == 198 && data == 0) {
		return BlockImageLoader.create(["grass_path", 0], ["grass_path", 0], ["grass_path", 0], BlockTypes.PATHGRASS, false);
	}
	if(id == 199) {
		return BlockImageLoader.create(["itemframe_background", 0], ["itemframe_background", 0], ["itemframe_background", 0], BlockTypes.NONE, false);
	}
	if(id == 246 && data == 0) {
		return BlockImageLoader.create(["glowing_obsidian", 0], ["glowing_obsidian", 0], ["glowing_obsidian", 0], BlockTypes.CUBE, false);
	}
	if(id == 247 && data == 0) {
		return BlockImageLoader.create(["reactor_core", 0], ["reactor_core", 0], ["reactor_core", 0], BlockTypes.CUBE, false);
	}
}
/**
 * BlockImageLoader
 * @author affogatoman
 * @since 2015-7-12
 */

/**
 * @namespace
 */
BlockTypes = {
    NONE: 0,
    CUBE: 1,
    STAIR: 2,
    SLAB: 3,
    SNOW: 4,
    PLATE: 5,
    CARPET: 5,
    TRAPDOOR: 6,
    FENCE: 7,
    PATHGRASS: 8,
    STONEWALL: 9,
    ENDPORTAL: 10,
    ENCHANTTABLE: 11,
    DAYLIGHTSENSOR: 12,
    BUTTON: 13,
    FENCEGATE: 14
};

/**
 * @namespace
 */
var BlockImageLoader = {
    TGA: null,
    META: null,
    META_MAPPED: null,
    MTRX: null,
    CANVAS: null
}

/**
 * @param {Bitmap} tga
 */
BlockImageLoader.init = function(tga) {
    if(tga instanceof android.graphics.Bitmap)
        BlockImageLoader.TGA = tga;
    
    if(BlockImageLoader.META == null)
        BlockImageLoader.META = JSON.parse(new java.lang.String(ModPE.getBytesFromTexturePack("images/terrain.meta"))+'');
        
    if(BlockImageLoader.META_MAPPED == null)
        BlockImageLoader.META_MAPPED = BlockImageLoader.META.map(function(e) {
            return e.name;
        });
        
    if(BlockImageLoader.TGA == null)
        BlockImageLoader.TGA = net.zhuoweizhang.mcpelauncher.texture.tga.TGALoader.load(ModPE.openInputStreamFromTexturePack("images/terrain-atlas.tga"), false);
        
    if(BlockImageLoader.MTRX == null)
        BlockImageLoader.MTRX = new android.graphics.Matrix();
        
    if(BlockImageLoader.CANVAS == null)
        BlockImageLoader.CANVAS = new android.graphics.Canvas();
};

/**
 * @param {String} name
 * @param {Number} data
 * @returns {Bitmap}
 */
BlockImageLoader.getBlockBitmap = function(name, data) {
    if(BlockImageLoader.META_MAPPED.indexOf(name) < 0)
        return android.graphics.Bitmap.createBitmap(1, 1, android.graphics.Bitmap.Config.RGB_565);
    var uvs = BlockImageLoader.META[BlockImageLoader.META_MAPPED.indexOf(name)].uvs[data];
    var x = uvs[0];
    var y = uvs[1];
    var width = uvs[2]-x;
    var height = uvs[3]-y;
    return android.graphics.Bitmap.createScaledBitmap(android.graphics.Bitmap.createBitmap(BlockImageLoader.TGA, x, y, width, height), 32, 32, false);
};

/**
 * Make cube-shaped image with three images
 * 
 * @param {Array} left
 * @param {Array} right
 * @param {Array} top
 * @param {Number} renderType
 * @param {Boolean} hasNoShadow
 * @returns {Bitmap}
 */
BlockImageLoader.create = function(left, right, top, renderType, hasNoShadow) {
    if(BlockImageLoader.TGA == null || BlockImageLoader.META == null)
        throw new Error("BlockImageLoader hasn't been initialized");
    
    if(!Array.isArray(left) || !Array.isArray(right) || !Array.isArray(top))
        throw new Error("Illegal argument type");
    
    var temp = android.graphics.Bitmap.createBitmap(51, 57, android.graphics.Bitmap.Config.ARGB_8888);
    left = BlockImageLoader.getBlockBitmap(left[0], left[1]);
    right = BlockImageLoader.getBlockBitmap(right[0], right[1]);
    top = BlockImageLoader.getBlockBitmap(top[0], top[1]);
    
    switch(renderType) {
        case BlockTypes.CUBE:
            temp = BlockImageLoader.createCube(left, right, top, temp, hasNoShadow, 32);
            break;
        
        case BlockTypes.STAIR:
            temp = BlockImageLoader.createStair(left, right, top, temp, hasNoShadow);
            break;
        
        case BlockTypes.SLAB:
            temp = BlockImageLoader.createCube(left, right, top, temp, hasNoShadow, 16);
            break;
        
        case BlockTypes.SNOW:
            temp = BlockImageLoader.createCube(left, right, top, temp, hasNoShadow, 4);
            break;
        
        case BlockTypes.CARPET:
            temp = BlockImageLoader.createCube(left, right, top, temp, hasNoShadow, 2);
            break;
        
        case BlockTypes.TRAPDOOR:
            temp = BlockImageLoader.createCube(left, right, top, temp, hasNoShadow, 6);
            break;
            
        case BlockTypes.FENCE:
            temp = BlockImageLoader.createFence(left, right, top, temp, hasNoShadow);
            break;
            
        case BlockTypes.PATHGRASS:
            temp = BlockImageLoader.createCube(left, right, top, temp, hasNoShadow, 30);
            break;
            
        case BlockTypes.STONEWALL:
            temp = BlockImageLoader.createWall(left, right, top, temp, hasNoShadow);
            break;
            
        case BlockTypes.ENDPORTAL:
            temp = BlockImageLoader.createCube(left, right, top, temp, hasNoShadow, 26);
            break;
            
        case BlockTypes.ENCHANTTABLE:
            temp = BlockImageLoader.createCube(left, right, top, temp, hasNoShadow, 24);
            break;
            
        case BlockTypes.DAYLIGHTSENSOR:
            temp = BlockImageLoader.createCube(left, right, top, temp, hasNoShadow, 12);
            break;
            
        case BlockTypes.BUTTON:
            temp = BlockImageLoader.createButton(left, right, top, temp, hasNoShadow);
            break;
            
        case BlockTypes.FENCEGATE:
            temp = BlockImageLoader.createFenceGate(left, right, top, temp, hasNoShadow);
            break;
            
        case BlockTypes.NONE:
        default:
            temp = android.graphics.Bitmap.createScaledBitmap(left, 64, 64, false);
            break;
    }
    
    return temp;
};

/**
 * @param {Bitmap} left
 * @param {Bitmap} right
 * @param {Bitmap} top
 * @param {Bitmap} temp
 * @param {Boolean} hasNoShadow
 * @param {Number} height
 * @returns {Bitmap}
 */
BlockImageLoader.createCube = function(left, right, top, temp, hasNoShadow, height) {
    var createCubeLeft = function(src) {
        src = android.graphics.Bitmap.createBitmap(src, 0, 32-height, 32, height);
        src = android.graphics.Bitmap.createScaledBitmap(src, 25, height, false);
        var mSrc = [0, 0, 25, 0, 25, height, 0, height];
        var mDst = [0, 0, 25, 12, 25, 12+height, 0, height];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(mSrc, 0, mDst, 0, 4);
        return android.graphics.Bitmap.createBitmap(src, 0, 0, src.getWidth(), src.getHeight(), BlockImageLoader.MTRX, false);
    };
    
    var createCubeRight = function(src) {
        src = android.graphics.Bitmap.createBitmap(src, 0, 32-height, 32, height);
        src = android.graphics.Bitmap.createScaledBitmap(src, 26, height, false);
        var mSrc = [0, 0, 26, 0, 26, height, 0, height];
        var mDst = [0, 12, 26, 0, 26, height, 0, 12+height]
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(mSrc, 0, mDst, 0, 4);
        return android.graphics.Bitmap.createBitmap(src, 0, 0, src.getWidth(), src.getHeight(), BlockImageLoader.MTRX, false);
    };
    
    var createCubeTop = function(src) {
        var mSrc = [0, 0, 32, 0, 32, 32, 0, 32];
        var mDst = [0, 13.5, 25, 0, 51, 13.5, 25, 26];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(mSrc, 0, mDst, 0, 4);
        return android.graphics.Bitmap.createBitmap(src, 0, 0, src.getWidth(), src.getHeight(), BlockImageLoader.MTRX, false);
    };
    
    left = createCubeLeft(left);
    right = createCubeRight(right);
    top = createCubeTop(top);
    
    BlockImageLoader.CANVAS.setBitmap(temp);
    var p = new android.graphics.Paint();
    if(hasNoShadow != false)
        p.setColorFilter(new android.graphics.PorterDuffColorFilter(android.graphics.Color.rgb(255-65, 255-65, 255-65), android.graphics.PorterDuff.Mode.MULTIPLY));
    BlockImageLoader.CANVAS.drawBitmap(left, 0, temp.getHeight()-left.getHeight(), p);
    if(hasNoShadow != false)
        p.setColorFilter(new android.graphics.PorterDuffColorFilter(android.graphics.Color.rgb(255-130, 255-130, 255-130), android.graphics.PorterDuff.Mode.MULTIPLY));
    BlockImageLoader.CANVAS.drawBitmap(right, 25, temp.getHeight()-right.getHeight(), p);
    BlockImageLoader.CANVAS.drawBitmap(top, 0, 32-height, null);
    return temp;
};

/**
 * @param {Bitmap} left
 * @param {Bitmap} right
 * @param {Bitmap} top
 * @param {Bitmap} temp
 * @param {Boolean} hasNoShadow
 * @returns {Bitmap}
 */
BlockImageLoader.createStair = function(left, right, top, temp, hasNoShadow) {
    var createLeft = function(left) {
        left = android.graphics.Bitmap.createScaledBitmap(left, 25, 32, false);
        var src = [0, 0, 25, 0, 25, 32, 0, 32];
        var dst = [0, 0, 25, 12, 25, 44, 0, 32];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        return android.graphics.Bitmap.createBitmap(left, 0, 0, left.getWidth(), left.getHeight(), BlockImageLoader.MTRX, false);
    };
    
    var createRight = function(right) {
        right = android.graphics.Bitmap.createScaledBitmap(right, 26, 32, false);
        var first = android.graphics.Bitmap.createBitmap(right, 0, 0, 26, 16);
        var src = [0, 0, 26, 0, 26, 16, 0, 16];
        var dst = [0, 13, 26, 0, 26, 16, 0, 29];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        first = android.graphics.Bitmap.createBitmap(first, 0, 0, first.getWidth(), first.getHeight(), BlockImageLoader.MTRX, false);
        
        var second = android.graphics.Bitmap.createBitmap(right, 0, 16, 26, 16);
        second = android.graphics.Bitmap.createBitmap(second, 0, 0, second.getWidth(), second.getHeight(), BlockImageLoader.MTRX, false);
        
        return [first, second];
    };
    
    var createTop = function(top) {
        top = android.graphics.Bitmap.createScaledBitmap(top, 32, 32, false);
        var first = android.graphics.Bitmap.createBitmap(top, 0, 0, 32, 16);
        var src = [0, 0, 32, 0, 32, 16, 0, 16];
        var dst = [0, 13.5, 26, 0, 38.25, 6.5, 12.75, 19.5];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        first = android.graphics.Bitmap.createBitmap(first, 0, 0, first.getWidth(), first.getHeight(), BlockImageLoader.MTRX, false);
        
        var second = android.graphics.Bitmap.createBitmap(top, 0, 16, 32, 16);
        second = android.graphics.Bitmap.createBitmap(second, 0, 0, second.getWidth(), second.getHeight(), BlockImageLoader.MTRX, false);
        
        return [first, second];
    };
    
    left = createLeft(left);
    right = createRight(right);
    top = createTop(top);
    
    BlockImageLoader.CANVAS.setBitmap(temp);
    var p = new android.graphics.Paint();
    if(hasNoShadow != false)
        p.setColorFilter(new android.graphics.PorterDuffColorFilter(android.graphics.Color.rgb(255-65, 255-65, 255-65), android.graphics.PorterDuff.Mode.MULTIPLY));
    BlockImageLoader.CANVAS.drawBitmap(left, 0, temp.getHeight()-left.getHeight(), p);
    if(hasNoShadow != false)
        p.setColorFilter(new android.graphics.PorterDuffColorFilter(android.graphics.Color.rgb(255-130, 255-130, 255-130), android.graphics.PorterDuff.Mode.MULTIPLY));
    BlockImageLoader.CANVAS.drawBitmap(right[0], 13, 6, p);
    BlockImageLoader.CANVAS.drawBitmap(right[1], 25, temp.getHeight()-right[1].getHeight(), p);
    BlockImageLoader.CANVAS.drawBitmap(top[0], 0, 0, null);
    BlockImageLoader.CANVAS.drawBitmap(top[1], 13, 22, null);
    
    return temp;
};

/**
 * @param {Bitmap} left
 * @param {Bitmap} right
 * @param {Bitmap} top
 * @param {Bitmap} temp
 * @param {Boolean} hasNoShadow
 * @returns {Bitmap}
 */
BlockImageLoader.createFence = function(left, right, top, temp, hasNoShadow) {
    var createVert = function(left, right, top) {
        left = android.graphics.Bitmap.createBitmap(left, 12, 0, 8, 32);
        left = android.graphics.Bitmap.createScaledBitmap(left, 6, 32, false);
        var src = [0, 0, 6, 0, 6, 32, 0, 32];
        var dst = [0, 0, 6, 3, 6, 35, 0, 32];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        left = android.graphics.Bitmap.createBitmap(left, 0, 0, left.getWidth(), left.getHeight(), BlockImageLoader.MTRX, false);
        
        right = android.graphics.Bitmap.createBitmap(right, 12, 0, 8, 32);
        right = android.graphics.Bitmap.createScaledBitmap(right, 6, 32, false);
        src = [0, 0, 6, 0, 6, 32, 0, 32];
        dst = [0, 3, 6, 0, 6, 32, 0, 35];
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        right = android.graphics.Bitmap.createBitmap(right, 0, 0, right.getWidth(), right.getHeight(), BlockImageLoader.MTRX, false);
        
        top = android.graphics.Bitmap.createBitmap(top, 12, 12, 8, 8);
        top = android.graphics.Bitmap.createScaledBitmap(top, 6, 6, false);
        src = [0, 0, 6, 0, 6, 6, 0, 5];
        dst = [0, 3, 6.5, 0, 12, 3, 3, 6.5];
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        top = android.graphics.Bitmap.createBitmap(top, 0, 0, top.getWidth(), top.getHeight(), BlockImageLoader.MTRX, false);
        
        var temp = android.graphics.Bitmap.createBitmap(12, 38, android.graphics.Bitmap.Config.ARGB_8888);
        BlockImageLoader.CANVAS.setBitmap(temp);
        var p = android.graphics.Paint();
        if(hasNoShadow != false)
            p.setColorFilter(new android.graphics.PorterDuffColorFilter(android.graphics.Color.rgb(255-65, 255-65, 255-65), android.graphics.PorterDuff.Mode.MULTIPLY));
        BlockImageLoader.CANVAS.drawBitmap(left, 0, 3, p);
        if(hasNoShadow != false)
            p.setColorFilter(new android.graphics.PorterDuffColorFilter(android.graphics.Color.rgb(255-130, 255-130, 255-130), android.graphics.PorterDuff.Mode.MULTIPLY));
        BlockImageLoader.CANVAS.drawBitmap(right, 6, 3, p);
        BlockImageLoader.CANVAS.drawBitmap(top, 0, 0, null);
        
        return temp;
    };
    
    var createHorz = function(left, right, top, type) {
        left = android.graphics.Bitmap.createBitmap(left, 0, 2+type*16, 32, 4);
        var src = [0, 0, 32, 0, 32, 4, 0, 4];
        var dst = [0, 0, 32, 16, 32, 20, 0, 4];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        left = android.graphics.Bitmap.createBitmap(left, 0, 0, left.getWidth(), left.getHeight(), BlockImageLoader.MTRX, false);
        
        right = android.graphics.Bitmap.createBitmap(right, 15, 2+type*16, 3, 4);
        src = [0, 0, 3, 0, 3, 4, 0, 4];
        dst = [0, 2, 3, 0, 3, 4, 0, 6];
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        right = android.graphics.Bitmap.createBitmap(right, 0, 0, right.getWidth(), right.getHeight(), BlockImageLoader.MTRX, false);
        
        top = android.graphics.Bitmap.createBitmap(top, 15, 0, 2, 32);
        top = android.graphics.Bitmap.createScaledBitmap(top, 2, 35, false);
        src = [0, 0, 2, 0, 2, 35, 0, 35];
        dst = [0, 2, 5, 0, 35, 15, 32, 17];
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        top = android.graphics.Bitmap.createBitmap(top, 0, 0, top.getWidth(), top.getHeight(), BlockImageLoader.MTRX, false);
        
        var temp = android.graphics.Bitmap.createBitmap(35, 22, android.graphics.Bitmap.Config.ARGB_8888);
        BlockImageLoader.CANVAS.setBitmap(temp);
        var p = android.graphics.Paint();
        if(hasNoShadow != false)
            p.setColorFilter(new android.graphics.PorterDuffColorFilter(android.graphics.Color.rgb(255-65, 255-65, 255-65), android.graphics.PorterDuff.Mode.MULTIPLY));
        BlockImageLoader.CANVAS.drawBitmap(left, 0, 2, p);
        if(hasNoShadow != false)
            p.setColorFilter(new android.graphics.PorterDuffColorFilter(android.graphics.Color.rgb(255-130, 255-130, 255-130), android.graphics.PorterDuff.Mode.MULTIPLY));
        BlockImageLoader.CANVAS.drawBitmap(right, 32, 16, p);
        BlockImageLoader.CANVAS.drawBitmap(top, 0, 1, null);
        
        return temp;
    };
    
    var vert = createVert(left, right, top);
    var horz1 = createHorz(left, right, top, 0);
    var horz2 = createHorz(left, right, top, 1);
    
    BlockImageLoader.CANVAS.setBitmap(temp);
    BlockImageLoader.CANVAS.drawBitmap(vert, 10, 5, null);
    BlockImageLoader.CANVAS.drawBitmap(vert, temp.getWidth()-vert.getWidth()-10, temp.getHeight()-vert.getHeight()-5, null);
    BlockImageLoader.CANVAS.drawBitmap(horz1, 8, 6, null);
    BlockImageLoader.CANVAS.drawBitmap(horz2, 8, 21, null);
    
    return temp;
};

/**
 * @param {Bitmap} left
 * @param {Bitmap} right
 * @param {Bitmap} top
 * @param {Bitmap} temp
 * @param {Boolean} hasNoShadow
 * @returns {Bitmap}
 */
BlockImageLoader.createWall = function(left, right, top, temp, hasNoShadow) {
    var createVert = function(left, right, top) {
        left = android.graphics.Bitmap.createBitmap(left, 8, 0, 16, 32);
        left = android.graphics.Bitmap.createScaledBitmap(left, 13, 32, false);
        var src = [0, 0, 13, 0, 13, 32, 0, 32];
        var dst = [0, 0, 13, 6, 13, 38, 0, 32];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        left = android.graphics.Bitmap.createBitmap(left, 0, 0, left.getWidth(), left.getHeight(), BlockImageLoader.MTRX, false);
        
        right = android.graphics.Bitmap.createScaledBitmap(right, 13, 32, false);
        src = [0, 0, 13, 0, 13, 32, 0, 32];
        dst = [0, 6, 13, 0, 13, 32, 0, 38];
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        right = android.graphics.Bitmap.createBitmap(right, 0, 0, right.getWidth(), right.getHeight(), BlockImageLoader.MTRX, false);
        
        top = android.graphics.Bitmap.createBitmap(top, 8, 8, 16, 16);
        top = android.graphics.Bitmap.createScaledBitmap(top, 13, 13, false);
        src = [0, 0, 13, 0, 13, 13, 0, 13];
        dst = [0, 6.5, 13.5, 0, 26, 6.5, 13.5, 13];
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        top = android.graphics.Bitmap.createBitmap(top, 0, 0, top.getWidth(), top.getHeight(), BlockImageLoader.MTRX, false);
        
        var temp = android.graphics.Bitmap.createBitmap(26, 44, android.graphics.Bitmap.Config.ARGB_8888);
        BlockImageLoader.CANVAS.setBitmap(temp);
        var p = new android.graphics.Paint();
        if(hasNoShadow != false)
            p.setColorFilter(new android.graphics.PorterDuffColorFilter(android.graphics.Color.rgb(255-65, 255-65, 255-65), android.graphics.PorterDuff.Mode.MULTIPLY));
        BlockImageLoader.CANVAS.drawBitmap(left, 0, 6, p);
        if(hasNoShadow != false)
            p.setColorFilter(new android.graphics.PorterDuffColorFilter(android.graphics.Color.rgb(255-130, 255-130, 255-130), android.graphics.PorterDuff.Mode.MULTIPLY));
        BlockImageLoader.CANVAS.drawBitmap(right, 13, 6, p);
        BlockImageLoader.CANVAS.drawBitmap(top, 0, 0, null);
        
        return temp;
    };
    
    var createHorzRight = function(right) {
        right = android.graphics.Bitmap.createBitmap(right, 8, 8, 16, 24);
        right = android.graphics.Bitmap.createScaledBitmap(right, 11, 24, false);
        var src = [0, 0, 11, 0, 11, 24, 0, 24];
        var dst = [0, 6, 11, 0, 11, 24, 0, 30];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        right = android.graphics.Bitmap.createBitmap(right, 0, 0, right.getWidth(), right.getHeight(), BlockImageLoader.MTRX, false);
        
        return right;
    };
    
    var createHorzTop = function(top) {
        top = android.graphics.Bitmap.createBitmap(top, 8, 0, 16, 32);
        var src = [0, 32, 0, 0, 16, 0, 16, 32];
        var dst = [0, 6.5, 11, 0, 21, 5, 10, 11.5];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        top = android.graphics.Bitmap.createBitmap(top, 0, 0, top.getWidth(), top.getHeight(), BlockImageLoader.MTRX, false);
        
        return top;
    };
    
    var vert = createVert(left, right, top);
    var rightHorz = createHorzRight(right);
    var topHorz = createHorzTop(top);
    
    BlockImageLoader.CANVAS.setBitmap(temp);
    var p = new android.graphics.Paint();
    BlockImageLoader.CANVAS.drawBitmap(vert, temp.getWidth()-vert.getWidth(), 0, null);
    if(hasNoShadow != false)
        p.setColorFilter(new android.graphics.PorterDuffColorFilter(android.graphics.Color.rgb(255-130, 255-130, 255-130), android.graphics.PorterDuff.Mode.MULTIPLY));
    BlockImageLoader.CANVAS.drawBitmap(rightHorz, 26, 18, p);
    BlockImageLoader.CANVAS.drawBitmap(topHorz, 16, 13, null);
    BlockImageLoader.CANVAS.drawBitmap(vert, 0, temp.getHeight()-vert.getHeight(), null);
    
    return temp;
};

/**
 * @param {Bitmap} left
 * @param {Bitmap} right
 * @param {Bitmap} top
 * @param {Bitmap} temp
 * @param {Boolean} hasNoShadow
 * @returns {Bitmap}
 */
BlockImageLoader.createButton = function(left, right, top, temp, hasNoShadow) {
    var createLeft = function(left) {
        left = android.graphics.Bitmap.createBitmap(left, 10, 12, 12, 8);
        left = android.graphics.Bitmap.createScaledBitmap(left, 9, 8, false);
        var src = [0, 0, 9, 0, 9, 8, 0, 9];
        var dst = [0, 0, 9, 5, 9, 13, 0, 9];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        left = android.graphics.Bitmap.createBitmap(left, 0, 0, left.getWidth(), left.getHeight(), BlockImageLoader.MTRX, false);
        
        return left;
    };
    
    var createRight = function(right) {
        right = android.graphics.Bitmap.createBitmap(right, 30, 12, 2, 8);
        right = android.graphics.Bitmap.createScaledBitmap(right, 4, 8, false);
        var src = [0, 0, 4, 0, 4, 8, 0, 8];
        var dst = [0, 2, 4, 0, 4, 8, 0, 10];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        right = android.graphics.Bitmap.createBitmap(right, 0, 0, right.getWidth(), right.getHeight(), BlockImageLoader.MTRX, false);
        
        return right;
    };
    
    var createTop = function(top) {
        top = android.graphics.Bitmap.createBitmap(top, 10, 0, 12, 4);
        var src = [0, 0, 12, 0, 12, 4, 0, 4];
        var dst = [3, 0, 13, 5, 9, 7, 0, 2];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        top = android.graphics.Bitmap.createBitmap(top, 0, 0, top.getWidth(), top.getHeight(), BlockImageLoader.MTRX, false);
        
        return top;
    };
    
    left = createLeft(left);
    right = createRight(right);
    top = createTop(top);
    
    BlockImageLoader.CANVAS.setBitmap(temp);
    var p = new android.graphics.Paint();
    if(hasNoShadow != false)
        p.setColorFilter(new android.graphics.PorterDuffColorFilter(android.graphics.Color.rgb(255-65, 255-65, 255-65), android.graphics.PorterDuff.Mode.MULTIPLY));
    BlockImageLoader.CANVAS.drawBitmap(left, 5, (temp.getHeight()-left.getHeight())/2+4, p);
    if(hasNoShadow != false)
        p.setColorFilter(new android.graphics.PorterDuffColorFilter(android.graphics.Color.rgb(255-130, 255-130, 255-130), android.graphics.PorterDuff.Mode.MULTIPLY));
    BlockImageLoader.CANVAS.drawBitmap(right, 14, (temp.getHeight()-left.getHeight())/2+8, p);
    BlockImageLoader.CANVAS.drawBitmap(top, 5, (temp.getHeight()-left.getHeight())/2+2, null);
    
    return temp;
};

/**
 * @param {Bitmap} left
 * @param {Bitmap} right
 * @param {Bitmap} top
 * @param {Bitmap} temp
 * @param {Boolean} hasNoShadow
 * @returns {Bitmap}
 */
BlockImageLoader.createFenceGate = function(left, right, top, temp, hasNoShadow) {
    var createVert = function(left, right, top, type) {
        left = android.graphics.Bitmap.createBitmap(left, type*28, 0, 4, 22);
        var src = [0, 0, 4, 0, 4, 22, 0, 22];
        var dst = [0, 0, 4, 3, 4, 25, 0, 22];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        left = android.graphics.Bitmap.createBitmap(left, 0, 0, left.getWidth(), left.getHeight(), BlockImageLoader.MTRX, false);
        
        right = android.graphics.Bitmap.createBitmap(right, 14, 0, 4, 22);
        var src = [0, 0, 4, 0, 4, 22, 0, 22];
        var dst = [0, 3, 4, 0, 4, 22, 0, 25];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        right = android.graphics.Bitmap.createBitmap(right, 0, 0, right.getWidth(), right.getHeight(), BlockImageLoader.MTRX, false);
        
        top = android.graphics.Bitmap.createBitmap(top, type*28, 14, 4, 4);
        var src = [0, 0, 4, 0, 4, 4, 0, 4];
        var dst = [0, 3, 4, 0, 8, 3, 4, 6];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        top = android.graphics.Bitmap.createBitmap(top, 0, 0, top.getWidth(), top.getHeight(), BlockImageLoader.MTRX, false);
        
        var temp = android.graphics.Bitmap.createBitmap(8, 28, android.graphics.Bitmap.Config.ARGB_8888);
        BlockImageLoader.CANVAS.setBitmap(temp);
        var p = new android.graphics.Paint();
        if(hasNoShadow != false)
            p.setColorFilter(new android.graphics.PorterDuffColorFilter(android.graphics.Color.rgb(255-65, 255-65, 255-65), android.graphics.PorterDuff.Mode.MULTIPLY));
        BlockImageLoader.CANVAS.drawBitmap(left, 0, 3, p);
        if(hasNoShadow != false)
            p.setColorFilter(new android.graphics.PorterDuffColorFilter(android.graphics.Color.rgb(255-130, 255-130, 255-130), android.graphics.PorterDuff.Mode.MULTIPLY));
        BlockImageLoader.CANVAS.drawBitmap(right, 4, 3, p);
        BlockImageLoader.CANVAS.drawBitmap(top, 0, 0, null);
        
        return temp;
    };
    
    var createHoriz = function(left, right, top) {
        left = android.graphics.Bitmap.createBitmap(left, 0, 2, 32, 14);
        var src = [0, 0, 32, 0, 32, 14, 0, 14];
        var dst = [0, 0, 26, 13, 26, 27, 0, 14];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        left = android.graphics.Bitmap.createBitmap(left, 0, 0, left.getWidth(), left.getHeight(), BlockImageLoader.MTRX, false);
        
        right = android.graphics.Bitmap.createBitmap(right, 14, 0, 4, 14);
        var src = [0, 0, 4, 0, 4, 14, 0, 14];
        var dst = [3, 0, 4, 0, 4, 14, 0, 17];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        right = android.graphics.Bitmap.createBitmap(right, 0, 0, right.getWidth(), right.getHeight(), BlockImageLoader.MTRX, false);
        
        top = android.graphics.Bitmap.createBitmap(top, 14, 0, 4, 32);
        var src = [0, 0, 4, 0, 4, 32, 0, 32];
        var dst = [0, 3, 4, 0, 30, 13, 26, 16];
        BlockImageLoader.MTRX.reset();
        BlockImageLoader.MTRX.setPolyToPoly(src, 0, dst, 0, 4);
        top = android.graphics.Bitmap.createBitmap(top, 0, 0, top.getWidth(), top.getHeight(), BlockImageLoader.MTRX, false);
        
        var temp = android.graphics.Bitmap.createBitmap(30, 30, android.graphics.Bitmap.Config.ARGB_8888);
        BlockImageLoader.CANVAS.setBitmap(temp);
        var p = new android.graphics.Paint();
        if(hasNoShadow != false)
            p.setColorFilter(new android.graphics.PorterDuffColorFilter(android.graphics.Color.rgb(255-65, 255-65, 255-65), android.graphics.PorterDuff.Mode.MULTIPLY));
        BlockImageLoader.CANVAS.drawBitmap(left, 0, 3, p);
        if(hasNoShadow != false)
            p.setColorFilter(new android.graphics.PorterDuffColorFilter(android.graphics.Color.rgb(255-130, 255-130, 255-130), android.graphics.PorterDuff.Mode.MULTIPLY));
        BlockImageLoader.CANVAS.drawBitmap(right, 26, 16, p);
        BlockImageLoader.CANVAS.drawBitmap(top, 0, 0, null);
        
        return temp;
    };
    
    var vert1 = createVert(left, right, top, 0);
    var vert2 = createVert(left, right, top, 1);
    var horz = createHoriz(left, right, top);
    
    BlockImageLoader.CANVAS.setBitmap(temp);
    BlockImageLoader.CANVAS.drawBitmap(vert1, 13, 5, null);
    BlockImageLoader.CANVAS.drawBitmap(vert2, 35, 15, null);
    BlockImageLoader.CANVAS.drawBitmap(horz, 13, 8, null);
    
    return temp;
};

/**
 * @param {Bitmap} left
 * @param {Bitmap} right
 * @param {Bitmap} top
 * @param {Bitmap} temp
 * @param {Boolean} hasNoShadow
 * @returns {Bitmap}
 */
BlockImageLoader.createAnvil = function(left, right, top, temp, hasNoShadow) {
    
};

BlockImageLoader.init();